#!/usr/bin/python

import xbmc,xbmcgui,urllib,time,os

try: Emulating = xbmcgui.Emulating
except: Emulating = False

#get actioncodes from keymap.xml

ACTION_MOVE_LEFT            = 1 
ACTION_MOVE_RIGHT         = 2
ACTION_MOVE_UP              = 3
ACTION_MOVE_DOWN            = 4
ACTION_PAGE_UP              = 5
ACTION_PAGE_DOWN            = 6
ACTION_SELECT_ITEM        = 7
ACTION_HIGHLIGHT_ITEM            = 8
ACTION_PARENT_DIR         = 9
ACTION_PREVIOUS_MENU      = 10
ACTION_SHOW_INFO            = 11

ACTION_PAUSE         = 12
ACTION_STOP          = 13
ACTION_NEXT_ITEM            = 14
ACTION_PREV_ITEM            = 15

# jours de la semaine
jours = ["Lundi","Mardi","Mercredi","Jeudi","Vendredi","Samedi","Dimanche"]
# regions
regions = ["france","alsace","aquitaine","auvergne","basse_normandie","bourgogne","bretagne","centre","champagne",
           "corse","franche_comte","haute_normandie","languedoc","limousin","lorraine","midi_pyrenees","nord","paca",
           "ile_de_france","pays_de_loire","picardie","poitou","rhone_alpes"]
# chemin du script
HOME   = os.getcwd().replace(';','')
CONFIG = os.path.join(HOME,"region")

class Window(xbmcgui.Window):
   def __init__(self):
      xbmcgui.Window.__init__(self)

      try:
         f = open(CONFIG)
         try:
            self.region = f.readline()
         finally:
            f.close()
      except:
         self.region = "france"
      if self.region not in regions:
         self.region = "france"
         
      self.buttons = [] # boutons de controle
      self.today = time.localtime() # heure courante
      
      self.setCoordinateResolution(6)
      self.carte = None

      self.addControl(xbmcgui.ControlImage(0,0,720,576, os.path.join(HOME,'BackgroundWeather.png')))
      #~ self.addControl(xbmcgui.ControlImage(211,120,464,390, black))
      self.addControl(xbmcgui.ControlLabel(70, 61, 180, 20, 'Xbox Media Center', 'font13', 'ff111111'))
      self.lblTitre = xbmcgui.ControlLabel(260, 59, 300, 20, 'Mto - '+self.region.replace("_"," ").title(), 'font14', 'ff111111')
      self.addControl(self.lblTitre)

      # Changer de rgion
      self.btnChange = xbmcgui.ControlButton(250, 520, 150, 33, "Changer de rgion",noFocusTexture='button-nofocus.png')
      self.addControl (self.btnChange)
      # Rgion par dfaut
      self.btnDefaut = xbmcgui.ControlButton(486, 520, 150, 33, "Rgion par dfaut",noFocusTexture='button-nofocus.png')
      self.addControl (self.btnDefaut)

      # Ajout des boutons
      for count in range(0,8,2):
         # Label du jour
         self.addControl(xbmcgui.ControlLabel(50, 110 + count*50, 150, 33, jours[(self.today[6]+count/2)%len(jours)], 'special13', 'ff111111'))
         # Bouton matin
         self.buttons.append(xbmcgui.ControlButton(50, 142 + count*50, 150, 33, "En matine",noFocusTexture='button-nofocus.png',textXOffset=17))
         self.addControl(self.buttons[count])
         # bouton aprem
         self.buttons.append(xbmcgui.ControlButton(50, 174 + count*50, 150, 33, "En aprs-midi",noFocusTexture='button-nofocus.png',textXOffset=17))
         self.addControl(self.buttons[count+1])
      
      # Deplacements entre les boutons
      nbButtons = len(self.buttons)
      for count in range(nbButtons):
         self.buttons[count].controlDown (self.buttons[(count+1)%nbButtons])
         self.buttons[count].controlUp   (self.buttons[(count-1)%nbButtons])
         self.buttons[count].controlRight(self.btnChange)
         self.buttons[count].controlLeft (self.btnDefaut)

      # 1er bouton (matin ou aprem ?)
      if self.today[3] > 12 or self.today[3] < 6:
         # on est l'aprem ou la nuit
         # TODO: a voir quand F2 met a jour la matine ?
         self.removeControl(self.buttons[0])
         self.buttons[1].controlUp   (self.buttons[-1])
         self.buttons[-1].controlDown(self.buttons[1])
         self.indexFirst = 1
      else:
         self.indexFirst = 0
      self.showCarte(self.indexFirst)
      self.setFocus(self.buttons[self.indexFirst])
         
      # Deplacements depuis btnChange,btnDefaut
      self.btnChange.controlLeft (self.buttons[-1])
      self.btnChange.controlRight(self.btnDefaut)
      self.btnDefaut.controlLeft (self.btnChange)
      self.btnDefaut.controlRight(self.buttons[-1])

   def onAction(self, action):
      if action == ACTION_PREVIOUS_MENU:
         self.close()   
      
   def onControl(self, control):
      for count in range(len(self.buttons)):
         if control == self.buttons[count]:
            self.showCarte(count)
            self.setFocus(self.buttons[count])
            break
      if control == self.btnChange:
         # changer de rgion
         self.region = self.chooseRegion()
         self.lblTitre.setLabel('Mto - '+self.region.replace("_"," ").title())
         self.showCarte(self.indexFirst)
         self.setFocus(self.buttons[self.indexFirst])
      elif control == self.btnDefaut:
         # choisir la rgion par defaut
         self.region = self.chooseRegion()
         #~ region = "bretagne"
         self.lblTitre.setLabel('Mto - '+self.region.replace("_"," ").title())
         self.showCarte(self.indexFirst)
         self.setFocus(self.buttons[self.indexFirst])
         try:
            f = open(CONFIG,"w")
            try:
               f.write(self.region)
            finally:
               f.close()
         except  Exception, e:
            self.message("Impossible de sauvegarder la rgion par dfaut ("+self.region+")\n"+str(e))
         

   def showCarte (self,index):
      """ Affiche la carte mto correspondant  l'index"""
      # download image
      if index % 2 == 0:
         ampm = "am"
      else:
         ampm = "pm"
      url  = "http://meteo.france2.fr/img/f2-"+ self.region + "-512x384-j" + str(index/2) + ampm + ".jpg"
      file = os.path.join(HOME,"Cartes",self.region + str(index/2) + ampm + ".jpg")
      print url,file
      try:
         loc = urllib.URLopener()
         loc.retrieve(url, file)
      except Exception, e:
         self.message("Chargement chou...\nVrifiez votre connexion internet et ressayez.\n"+str(e))
      # display control
      if self.carte == None:
         self.carte = xbmcgui.ControlImage(211,120,464,390,file)
         self.addControl(self.carte)
      else:
         self.carte.setImage(file)

   def chooseRegion(self):
      """Affiche la liste des rgions pour choix.
      return: nom de la rgion choisie"""
      liste = xbmcgui.Dialog()
      index = liste.select("Rgions",[r.replace("_"," ").title() for r in regions])
      return regions[index]

   def message(self, messageText):
      dialog = xbmcgui.Dialog()
      dialog.ok("Prvisions Mtorologiques:", messageText)



w = Window()
w.doModal()
del w
